/*
 *  linux/include/asm-arm/arch-cpe/debug-macro.S
 *
 *  Copyright (C) 2005 Faraday corp.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 *  32-bit debugging code
 */
#include <linux/config.h>
#include <linux/linkage.h>
#include <asm/hardware.h>
/* Luke Lee 04/14/2005 ins begin */
#include <asm/arch/cpe/cpe.h>

#define SERIAL_THR                     	0x00	 		/*  Transmitter Holding Register(Write).*/
#define SERIAL_RBR                     	0x00	 		/*  Receive Buffer register (Read).*/
#define SERIAL_IER                     	0x04	 		/*  Interrupt Enable register.*/
#define SERIAL_IIR                     	0x08	 		/*  Interrupt Identification register(Read).*/
#define SERIAL_FCR                     	0x08	 		/*  FIFO control register(Write).*/
#define SERIAL_EFR			0x08			//  ?????????????????????
#define SERIAL_LCR                     	0x0C	 		/*  Line Control register.*/
#define SERIAL_MCR                     	0x10	 		/*  Modem Control Register.*/
#define SERIAL_LSR                     	0x14	 		/*  Line status register(Read) .*/
#define SERIAL_MSR                     	0x18	 		/*  Modem Status register (Read).*/
#define SERIAL_SPR                     	0x1C     		/*  Scratch pad register */
#define SERIAL_DLL                     	0x0      		/*  Divisor Register LSB */
#define SERIAL_DLM                     	0x4      		/*  Divisor Register MSB */
#define SERIAL_PSR                     	0x8     		/* Prescale Divison Factor */


/* LSR Register */
#define SERIAL_LSR_DR                  0x1      	/* Data Ready */
#define SERIAL_LSR_OE                  0x2      	/* Overrun Error */
#define SERIAL_LSR_PE                  0x4      	/* Parity Error */
#define SERIAL_LSR_FE                  0x8      	/* Framing Error */
#define SERIAL_LSR_BI                  0x10     	/* Break Interrupt */
#define SERIAL_LSR_THRE                0x20     	/* THR Empty */
#define SERIAL_LSR_TE                  0x40     	/* Transmitte Empty */
#define SERIAL_LSR_DE                  0x80     	/* FIFO Data Error */

/* Luke Lee 04/14/2005 ins end */

/*Luke Lee TOFIX 03/17/2005:
	1. fix the following constants with constant names
	2. fix ugly busyuart
	FIXED : 04/14/2005
 */

		.macro	addruart,rx
/* Luke Lee 04/14/2005 ins remarks ins #if 0 due to bug found */
#if 1
		mrc	p15, 0, \rx, c1, c0
		tst	\rx, #1			@ MMU enabled ?
		moveq	\rx, #0x98000000
		addeq   \rx, \rx, #0x2 << 20	@ physical base address of UART1
		movne	\rx, #0xf0000000
		addne	\rx, \rx, #0x09800000
		addne	\rx, \rx, #0x2 << 20	@ virtual base address of UART1
#else
		mrc	p15, 0, \rx, c1, c0
		tst	\rx, #1			@ MMU enabled ?
		bne	1002f
		mov	\rx,    #0x98000000
		add	\rx, \rx, #0x200000	@ physical addr
		b	1003f
1002:		mov	\rx,    #0xf9000000
		add	\rx, \rx, #0x820000	@ virtual addr
1003:
#endif
		.endm

		.macro	senduart,rd,rx
/* Luke Lee 04/14/2005 mod 1 */
		strb	\rd, [\rx, #SERIAL_THR]
		.endm

		.macro	waituart,rd,rx
/* Luke Lee 04/14/2005 mod 2 ins remarks */
/*	
1001:		ldrb	\rd, [\rx, #SERIAL_LSR]	@ LSR
		tst	\rd, #SERIAL_LSR_THRE	@ test empty
		bne	1001b
*/
		mov	\rd, #0xf000
1001:		subs	\rd, \rd, #1
		bne	1001b	
		.endm

		.macro	busyuart,rd,rx
/* Luke Lee 04/14/2005 ins 3 */
		nop
/*	
1001:		ldrb	\rd, [\rx, #SERIAL_LSR]	@ LSR
		tst	\rd, #SERIAL_LSR_THRE	@ test empty
		bne	1001b
*/
		mov	\rd, #0xf000
1010:		subs	\rd, \rd, #1
		bne	1010b
		.endm
		
